[build-system]
requires = ["hatchling", "hatch-vcs","pre-commit"]
build-backend = "hatchling.build"

[project]
name = "otter_grader_service"
authors = [
    {name = "Bengt Giger", email = "bgiger@ethz.ch"}
]
description = "Perform grading of Jupyter notebooks prepared by otter-grader."
keywords = ["python", "jupyter", "grading", "education"]
readme = "README.md"
requires-python = ">=3.9"
dynamic = [
    "version",
]
classifiers = [
    "Programming Language :: Python :: 3",
    "License :: OSI Approved :: BSD License",
    "Operating System :: OS Independent",
]
dependencies = [
    "apscheduler<4.0.0",
    "fastapi",
    "gunicorn",
    "pika",
    "pydantic",
    "starlette",
    "uvicorn[standard]",
    "requests"
]

[project.optional-dependencies]
test = [
    "pytest"
]
lint = [
    "pre-commit"
]
build = [
    "build",
    "twine"
]

[tool.hatch.version]
source = "vcs"

[tool.hatch.build.hooks.vcs]
version-file = "_version.py"

[tool.hatch.build.targets.wheel]
packages = ["src/otter_grader_service"]

[tool.hatch.build.targets.sdist]
include = ["src/*", "devel_*.py"]

[project.scripts]
otter-grader-pusher = "otter_grader_service.pusher.main:main"
otter-grader-grader = "otter_grader_service.grading.main:main"
otter-grader-responder = "otter_grader_service.responder.main:main"
